/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.12.07
;  *       @˾/            : ΢-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : ΢ ˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                  UART
******************************************************************************/

#include "stdio.h"
#include "MC51F7424_COMMON.h"
#include "UART.h"

/************************************************
;  *    @            : UART1_Init
;  *    @˵              : UARTʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void UART1_Init(uint16_t baud)
{
    uint16_t cacl_temp=0;
    
    PCON  |= DEF_SET_BIT7;        //UART1ģ
    SCON_1|= DEF_SET_BIT6;        //ʽ1

    cacl_temp= ((SYSTEM_CLOCK >> 4)/baud);
    cacl_temp= 65535-cacl_temp+1;    
    BRGCR |= DEF_SET_BIT7;        //ʹܲʷ      
    BRGH = (uint8_t)(cacl_temp >>8);
    BRGL = (uint8_t)(cacl_temp);    
}

char putchar(char tx_data)
{
    SBUF_1 = tx_data;             //дݵUARTݼĴ
    while (!(SCON_1 & 0x02));     //ȴǰݷ
    SCON_1 &= ~DEF_SET_BIT1;
    return tx_data;
}
