/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.12.07
;  *       @˾/            : ΢-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : ΢ ˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                   ADC
******************************************************************************/
#include "MC51F7424_COMMON.h"
#include "GPIO.h"
#include "ADC.h"

idata uint16_t ADC_SR0,ADC_SR1,ADC_SR2=0;   // XDATAɨ
uint8_t ADC_FLAG;

/************************************************
;  *    @            : ADC_Init
;  *    @˵              : ADCʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void ADC_Init(void)
{
    ADCCR0 = 0x01<<2;                 // οѹ VDD
    ADCCR2 = (0x01<<7)|(0x7<<4);      // ADCʱԴѡHIRC 48M ,Fadcclk/3,3clk sample
    ADCCR3 = 0x00;                    // ϴݣҶ룬12bitADC
    ADCCR4 = (0x01<<3);               // ʹPWM1ADC

    ADASCR0 =(0x01<<1);                // һδɨһ
    ADASCR0 |= 0x01;                   // Զɨ
    ADASCR0 |=(ADC_CH_NUM<<3);         // ÿɨͨ

    ADASCR1 = (uint8_t) (ADC_RESULT_ADD);   // ԶɨXDATAַ8λ
    ADASCR2 = (uint8_t) ((ADC_RESULT_ADD >> 8)&0x07);      // ԶɨXDATAַ3λ
    ADASCR2 |= (ADC_CH_NUM <<3);            // ÿADC
    
    ADSEQR0 = 0xDB;     //Ch1=LDO_OUT,Ch0=OP0OUT
    ADSEQR1 = 0xBF;     //Ch3=OP0OUT,Ch2=GND
    ADSEQR2 = 0xBF;     //Ch5=OP0OUT,Ch4=GND
     
    ADCCR0 |= 0x01;     //ʹADC
    ADCIE  = ENABLE;
    
    IP |=0x40;          //ȼ
    IPH |=0x40;
}

/*****  ADCж TEST_PINָʾ ***********/
void Adc_ISR(void)   interrupt ADC_IRQn
{
    TEST_PIN =HIGH;
    ADC_SR0 = (READ_XDATA(ADC_RESULT_ADD) <<8)+ READ_XDATA(ADC_RESULT_ADD+1);
    ADC_SR1 = (READ_XDATA(ADC_RESULT_ADD+2) <<8)+ READ_XDATA(ADC_RESULT_ADD+3);
    ADC_SR2 = (READ_XDATA(ADC_RESULT_ADD+4) <<8)+ READ_XDATA(ADC_RESULT_ADD+5); 
    TEST_PIN =LOW;

    ADCCR0 &= ~0x10;    //clear ADCIF
    ADC_FLAG = 1;
    ADASCR1 = (uint8_t) (ADC_RESULT_ADD);   // ԶɨXDATAַ8λ
    ADASCR2 = (uint8_t) ((ADC_RESULT_ADD >> 8)&0x07);      // ԶɨXDATAַ3λ
    ADASCR2 |= (ADC_CH_NUM <<3);            // ÿADC   
}
