/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.12.07
;  *       @˾/            : ΢-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : ΢ ˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                    GPIOʼ
;  *   CMP1 OUT P00
;  *   TEST_PIN P02
;  *   LED2   P03
;  *   TX     P04
;  *   PWM    P11,P06,P10,P05,P07,P10
;  *   OPAOUT P20
;  *   OPA0P  P21
******************************************************************************/
#include "MC51F7424_COMMON.h"
#include "GPIO.h"

/************************************************
;  *    @            : GPIO_Init
;  *    @˵              : ˿ڳʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void GPIO_Init(void)
{
    SET_ALL_GPIO_PUSHPULL_MODE;

    PWM1A_MAP  = 0x11; //UH=P1.1
    PWM1AN_MAP = 0x06; //UL=P0.6
    PWM1B_MAP  = 0x10; //VH=P1.0
    PWM1BN_MAP = 0x05; //VL=P0.5
    PWM1C_MAP  = 0x07; //WH=P0.7
    PWM1CN_MAP = 0x10; //WL=P1.0

    P20_HIGH_Z_MODE;   // OPAOUT
    P21_HIGH_Z_MODE;   // OPA0P
    CMP1O_MAP = 0x00;  // P0.0

    TX1_MAP = 0x04;    // PIN04   
//    RX1_MAP = 0x05;
}
